OpenTTD Source: NWidgetBackground Class Reference

OpenTTD Source 13.1

Public Member Functions | Private Attributes
NWidgetBackground Class Reference
Hierarchical widgets

Nested widget with a child. More...

`#include <widget_type.h>`

Inheritance diagram for NWidgetBackground:

## Public Member Functions
| NWidgetBackground (WidgetType tp, Colours colour, int index, NWidgetPIPContainer *child=nullptr)
| Constructor parent nested widgets. More...
void | Add (NWidgetBase *nwid)
| Add a child to the parent. More...
void | SetPIP (uint8 pip_pre, uint8 pip_inter, uint8 pip_post)
| Set additional pre/inter/post space for the background widget. More...
void | AdjustPaddingForZoom () override
void | SetupSmallestSize (Window *w, bool init_array) override
void | AssignSizePosition (SizingType sizing, uint x, uint y, uint given_width, uint given_height, bool rtl) override
void | FillNestedArray (NWidgetBase **array, uint length) override
void | Draw (const Window *w) override
NWidgetCore * | GetWidgetFromPos (int x, int y) override
NWidgetBase * | GetWidgetOfType (WidgetType tp) override
| Retrieve a widget by its type. More...
Public Member Functions inherited from NWidgetCore
| NWidgetCore (WidgetType tp, Colours colour, uint fill_x, uint fill_y, uint32 widget_data, StringID tool_tip)
| Initialization of a 'real' widget. More...
void | SetIndex (int index)
| Set index of the nested widget in the widget array. More...
void | SetDataTip (uint32 widget_data, StringID tool_tip)
| Set data and tool tip of the nested widget. More...
void | SetToolTip (StringID tool_tip)
| Set the tool tip of the nested widget. More...
void | SetTextColour (TextColour colour)
| Set the text colour of the nested widget. More...
void | SetAlignment (StringAlignment align)
| Set the text/image alignment of the nested widget. More...
void | SetLowered (bool lowered)
| Lower or raise the widget. More...
bool | IsLowered () const
| Return whether the widget is lowered.
void | SetDisabled (bool disabled)
| Disable (grey-out) or enable the widget. More...
bool | IsDisabled () const
| Return whether the widget is disabled.
bool | IsHighlighted () const override
| Return whether the widget is highlighted.
TextColour | GetHighlightColour () const override
| Return the colour of the highlight.
void | SetHighlighted (TextColour highlight_colour) override
| Highlight the widget or not. More...
Public Member Functions inherited from NWidgetResizeBase
| NWidgetResizeBase (WidgetType tp, uint fill_x, uint fill_y)
| Constructor for resizable nested widgets. More...
void | SetMinimalSize (uint min_x, uint min_y)
| Set minimal size of the widget. More...
void | SetMinimalSizeAbsolute (uint min_x, uint min_y)
| Set absolute (post-scaling) minimal size of the widget. More...
void | SetMinimalTextLines (uint8 min_lines, uint8 spacing, FontSize size)
| Set minimal text lines for the widget. More...
void | SetFill (uint fill_x, uint fill_y)
| Set the filling of the widget from initial size. More...
void | SetResize (uint resize_x, uint resize_y)
| Set resize step of the widget. More...
Public Member Functions inherited from NWidgetBase
| NWidgetBase (WidgetType tp)
| Base class constructor. More...
void | SetPadding (uint8 top, uint8 right, uint8 bottom, uint8 left)
| Set additional space (padding) around the widget. More...
void | SetPadding (const RectPadding &padding)
| Set additional space (padding) around the widget. More...
uint | GetHorizontalStepSize (SizingType sizing) const
| Get the horizontal sizing step. More...
uint | GetVerticalStepSize (SizingType sizing) const
| Get the vertical sizing step. More...
virtual void | SetDirty (const Window *w) const
| Mark the widget as 'dirty' (in need of repaint). More...
Rect | GetCurrentRect () const
Public Member Functions inherited from ZeroedMemoryAllocator
void * | operator new (size_t size)
| Memory allocator for a single class instance. More...
void * | operator new[] (size_t size)
| Memory allocator for an array of class instances. More...
void | operator delete (void *ptr)
| Memory release for a single class instance. More...
void | operator delete[] (void *ptr)
| Memory release for an array of class instances. More...

## Private Attributes
NWidgetPIPContainer * | child
| Child widget.

## Additional Inherited Members
Data Fields inherited from NWidgetCore
NWidgetDisplay | disp_flags
| Flags that affect display and interaction with the widget.
Colours | colour
| Colour of this widget.
int | index
| Index of the nested widget in the widget array of the window (`-1` means 'not used').
uint32 | widget_data
| Data of the widget. More...
StringID | tool_tip
| Tooltip of the widget. More...
int | scrollbar_index
| Index of an attached scrollbar.
TextColour | highlight_colour
| Colour of highlight.
TextColour | text_colour
| Colour of text within widget.
StringAlignment | align
| Alignment of text/image within widget.
Data Fields inherited from NWidgetResizeBase
uint | min_x
| Minimal horizontal size of only this widget.
uint | min_y
| Minimal vertical size of only this widget.
bool | absolute
| Set if minimum size is fixed and should not be resized.
uint | uz_min_x
| Unscaled Minimal horizontal size of only this widget.
uint | uz_min_y
| Unscaled Minimal vertical size of only this widget.
uint8 | uz_text_lines
| 'Unscaled' text lines, stored for resize calculation.
uint8 | uz_text_spacing
| 'Unscaled' text padding, stored for resize calculation.
FontSize | uz_text_size
| 'Unscaled' font size, stored for resize calculation.
Data Fields inherited from NWidgetBase
WidgetType | type
| Type of the widget / nested widget.
uint | fill_x
| Horizontal fill stepsize (from initial size, `0` means not resizable).
uint | fill_y
| Vertical fill stepsize (from initial size, `0` means not resizable).
uint | resize_x
| Horizontal resize step (`0` means not resizable).
uint | resize_y
| Vertical resize step (`0` means not resizable).
uint | smallest_x
| Smallest horizontal size of the widget in a filled window.
uint | smallest_y
| Smallest vertical size of the widget in a filled window.
uint | current_x
| Current horizontal size (after resizing).
uint | current_y
| Current vertical size (after resizing).
int | pos_x
| Horizontal position of top-left corner of the widget in the window.
int | pos_y
| Vertical position of top-left corner of the widget in the window.
NWidgetBase * | next
| Pointer to next widget in container. Managed by parent container widget.
NWidgetBase * | prev
| Pointer to previous widget in container. Managed by parent container widget.
RectPadding | padding
| Padding added to the widget. Managed by parent container widget. (parent container may swap left and right for RTL)
RectPadding | uz_padding
| Unscaled padding, for resize calculation.
Protected Member Functions inherited from NWidgetBase
void | StoreSizePosition (SizingType sizing, uint x, uint y, uint given_width, uint given_height)
| Store size and position. More...

## Detailed Description

Nested widget with a child.

Definition at line 589 of file widget_type.h.

## Constructor & Destructor Documentation

## ◆ NWidgetBackground()

NWidgetBackground::NWidgetBackground | ( | WidgetType | tp,
|  | Colours | colour,
|  | int | index,
|  | NWidgetPIPContainer * | child = `nullptr`
| ) |  |

Constructor parent nested widgets.

Parameters

  tp | Type of parent widget.
  colour | Colour of the parent widget.
  index | Index in the widget array used by the window system.
  child | Child container widget (if supplied). If not supplied, a vertical container will be inserted while adding the first child widget.

Definition at line 2089 of file widget.cpp.

References child, NWidgetCore::index, SA_LEFT, SA_TOP, NWidgetCore::SetAlignment(), NWidgetCore::SetIndex(), WWT_FRAME, WWT_INSET, and WWT_PANEL.

## Member Function Documentation

## ◆ Add()

void NWidgetBackground::Add | ( | NWidgetBase * | nwid | ) |

Add a child to the parent.

Parameters

  nwid | Nested widget to add to the background widget.

Unless a child container has been given in the constructor, a parent behaves as a vertical container. You can add several children to it, and they are put underneath each other.

Definition at line 2109 of file widget.cpp.

References NWidgetContainer::Add(), and child.

Referenced by MakeWidgetTree().

## ◆ AssignSizePosition()

void NWidgetBackground::AssignSizePosition | ( | SizingType | sizing,
|  | uint | x,
|  | uint | y,
|  | uint | given_width,
|  | uint | given_height,
|  | bool | rtl
| ) |  |
| overridevirtual

Assign size and position to the widget.

Parameters

  sizing | Type of resizing to perform.
  x | Horizontal offset of the widget relative to the left edge of the window.
  y | Vertical offset of the widget relative to the top edge of the window.
  given_width | Width allocated to the widget.
  given_height | Height allocated to the widget.
  rtl | Adapt for right-to-left languages (position contents of horizontal containers backwards).

Afterwards, pos_x and pos_y contain the top-left position of the widget, smallest_x and smallest_y contain the smallest size such that all widgets of the window are consistent, and current_x and current_y contain the current size.

Reimplemented from NWidgetResizeBase.

Definition at line 2208 of file widget.cpp.

## ◆ Draw()

void NWidgetBackground::Draw | ( | const Window * | w | ) |
| overridevirtual

Draw the widgets of the tree. The function calls Window::DrawWidget for each widget with a non-negative index, after the widget itself is painted.

Parameters

  w | Window that owns the tree.

Implements NWidgetBase.

Definition at line 2226 of file widget.cpp.

References NWidgetBase::current_x, and NWidgetBase::current_y.

## ◆ FillNestedArray()

void NWidgetBackground::FillNestedArray | ( | NWidgetBase ** | array,
|  | uint | length
| ) |  |
| overridevirtual

Fill the Window::nested_array array with pointers to nested widgets in the tree.

Parameters

  array | Base pointer of the array.
  length | Length of the array.

Reimplemented from NWidgetCore.

Definition at line 2220 of file widget.cpp.

References child, NWidgetContainer::FillNestedArray(), and NWidgetCore::index.

## ◆ GetWidgetFromPos()

NWidgetCore * NWidgetBackground::GetWidgetFromPos | ( | int | x,
|  | int | y
| ) |  |
| overridevirtual

Retrieve a widget by its position.

Parameters

  x | Horizontal position relative to the left edge of the window.
  y | Vertical position relative to the top edge of the window.

Returns
  Returns the deepest nested widget that covers the given position, or `nullptr` if no widget can be found.

Reimplemented from NWidgetCore.

Definition at line 2263 of file widget.cpp.

## ◆ GetWidgetOfType()

NWidgetBase * NWidgetBackground::GetWidgetOfType | ( | WidgetType | tp | ) |
| overridevirtual

Retrieve a widget by its type.

Parameters

  tp | Widget type to search for.

Returns
  Returns the first widget of the specified type, or `nullptr` if no widget can be found.

Reimplemented from NWidgetBase.

Definition at line 2273 of file widget.cpp.

References child, NWidgetContainer::GetWidgetOfType(), and NWidgetBase::type.

## ◆ SetPIP()

void NWidgetBackground::SetPIP | ( | uint8 | pip_pre,
|  | uint8 | pip_inter,
|  | uint8 | pip_post
| ) |  |

Set additional pre/inter/post space for the background widget.

Parameters

  pip_pre | Additional space in front of the first child widget (above for the vertical container, at the left for the horizontal container).
  pip_inter | Additional space between two child widgets.
  pip_post | Additional space after the last child widget (below for the vertical container, at the right for the horizontal container).

Note
  Using this function implies that the widget has (or will have) child widgets.

Definition at line 2127 of file widget.cpp.

References child, and NWidgetPIPContainer::SetPIP().

## ◆ SetupSmallestSize()

void NWidgetBackground::SetupSmallestSize | ( | Window * | w,
|  | bool | init_array
| ) |  |
| overridevirtual

Compute smallest size needed by the widget.

The smallest size of a widget is the smallest size that a widget needs to display itself properly. In addition, filling and resizing of the widget are computed. The function calls Window::UpdateWidgetSize for each leaf widget and background widget without child with a non-negative index.

Parameters

  w | Window owning the widget.
  init_array | Initialize the `w->nested_array`.

Note
  After the computation, the results can be queried by accessing the smallest_x and smallest_y data members of the widget.

Implements NWidgetBase.

Definition at line 2141 of file widget.cpp.

References WidgetDimensions::bevel, child, NWidgetBase::fill_x, NWidgetBase::fill_y, FONT_HEIGHT_NORMAL, WidgetDimensions::frametext, GetStringBoundingBox(), RectPadding::Horizontal(), NWidgetCore::index, maxdim(), NWidgetResizeBase::min_x, NWidgetResizeBase::min_y, Window::nested_array, Window::nested_array_size, NWidgetBase::padding, NWidgetBase::resize_x, NWidgetBase::resize_y, WidgetDimensions::scaled, Window::SetStringParameters(), NWidgetBase::SetupSmallestSize(), NWidgetBase::smallest_x, NWidgetBase::smallest_y, NWidgetBase::type, RectPadding::Vertical(), NWidgetCore::widget_data, WWT_FRAME, and WWT_INSET.

The documentation for this class was generated from the following files:

- src/widget_type.h
- src/widget.cpp